"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBabelPresetReactOpts = void 0;
const utils_1 = require("@umijs/utils");
function getBabelPresetReactOpts(pkg) {
    const reactVer = Object.assign({}, pkg.dependencies, pkg.peerDependencies).react;
    let opts = {};
    if (reactVer) {
        const isLTRReact17 = utils_1.semver.subset(reactVer, '>=17.0.0-0');
        opts = {
            // use legacy jsx runtime for react@<17
            runtime: isLTRReact17 ? 'automatic' : 'classic',
            ...(isLTRReact17 ? {} : { importSource: undefined }),
        };
    }
    return opts;
}
exports.getBabelPresetReactOpts = getBabelPresetReactOpts;
