"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (api) => {
    api.addImportsCheckup(({ imports, mergedAlias, mergedExternals }) => {
        const errors = [];
        imports.forEach((i) => {
            var _a, _b, _c;
            const pkgName = (_a = i.path.match(/^(?:@[\w-]+\/)?[\w-]+/i)) === null || _a === void 0 ? void 0 : _a[0];
            const aliasKeys = Object.keys(mergedAlias);
            if (pkgName &&
                !((_b = api.pkg.dependencies) === null || _b === void 0 ? void 0 : _b[pkgName]) &&
                !((_c = api.pkg.peerDependencies) === null || _c === void 0 ? void 0 : _c[pkgName]) &&
                aliasKeys.every((k) => k !== i.path && !i.path.startsWith(`${k}/`)) &&
                !mergedExternals[i.path]) {
                errors.push({
                    type: 'error',
                    problem: `Source depend on \`${pkgName}\` but it is not in the \`dependencies\` or \`peerDependencies\``,
                    solution: 'Add it to the `dependencies` or `peerDependencies` of the package.json file',
                });
            }
        });
        return errors;
    });
};
